var EC = require('elliptic').ec

// Create and initialize EC context
var ec = new EC('secp256k1')

// Generate keys
var key = ec.genKeyPair()
key.priv.words;
// Sign the message's hash
var msgHash = [ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ]
var signature = key.sign(msgHash)

// Export DER encoded signature in Array
var derSign = signature.toDER()

// Verify signature
key.verify(msgHash, derSign);

const crypto = require("crypto");

const {privateKey, publicKey} = crypto.generateKeyPairSync("rsa", {
  modulusLength: 512, 
  namedCurve: 'prime128v1',
  publicKeyEncoding: { type: 'spki', format: 'pem' },
  privateKeyEncoding: { type: 'pkcs1', format: 'pem' },
});

const {privateKey2, publicKey2} = crypto.generateKeyPairSync("rsa", {
  modulusLength: 2048, 
  namedCurve: 'secp384r1',
  publicKeyEncoding: { type: 'spki', format: 'pem' },
  privateKeyEncoding: { type: 'pkcs1', format: 'pem' },
});

const md5 = data => crypto.createHash('md5').update(data).digest("hex")
const data = 'our data'
const dataHash = md5(data)
'hash of the string \''+data+'\' is: '  + dataHash;

const sign = crypto.createSign('RSA-SHA256')
sign.update(dataHash)
sign.end()
const signature_ = sign.sign(privateKey);

const signedHash = signature_.toString("base64")

console.log({
  dataLocation: "rf://0xABCD/someUri",
  dataHash,
  signedHash
});

const verify = crypto.createVerify('RSA-SHA256')
verify.update(dataHash)
verify.end()
'key is ok: ' + verify.verify(publicKey, signature_);

const encryptedData = crypto.publicEncrypt(
    publicKey,
	Buffer.from(data)
);

encryptedData.toString("base64");

const decryptedData = crypto.privateDecrypt(
	privateKey,
	encryptedData
);

decryptedData.toString();